//
// Sum92Mac : Fix Fargo Files' sum
//
// 971126 Bryan Turner

#include <stdio.h>
#include <string.h>
#include <malloc.h>

struct TIVarHeader
	{
	long buf[4];
	short pad;
	char Description[40];
	short pad1;
	short pad2;
	short pad3;
	char varname[8];
	char type;
	char pad4;
	short padd;
	short filesize;
	short pad7;
	short pad5;
	short pad6;
	short pad8;
	short datasize;
	};

void InitHeader( TIVarHeader *theHeader, char *Desc, char *varName, char type, short size )
{
	theHeader->buf[0] = 'IT**';
	theHeader->buf[1] = '**29';
	theHeader->buf[2] = 0x616D0001;//0x01006D61;
	theHeader->buf[3] = 0x00006E69;//0x696E0000;
	theHeader->pad = 0;
	memcpy( theHeader->Description, Desc, 40);
	theHeader->pad1 = 0x0001;//0x0100;
	theHeader->pad2 = 0x0052;//0x5200;
	theHeader->pad3 = 0;
	memcpy( theHeader->varname, varName, 8);
	theHeader->type = type;
	theHeader->pad4 = 0x00;
	theHeader->padd = 0x0000;
	
	theHeader->datasize = ((size >> 8) & 0xFF) + ((size << 8) & 0xFF00);
	size += sizeof(TIVarHeader) + 2; // Size of header plus sum bytes at the end of the file
	theHeader->filesize = size;//(size << 8) | (size >> 8);
	
	theHeader->pad5 = 0x5AA5;//0xA55A;
	theHeader->pad6 = 0;
	theHeader->pad7 = 0;
	theHeader->pad8 = 0;
};

void SafeName( char *name )
{
	for ( int x=0; x<8; x++ )
		if (!(( name[x] >= 'A' && name[x] <= 'Z' ) ||
			( name[x] >= 'a' && name[x] <= 'z' ) || 
			( name[x] >= '0' && name[x] <= '9' ) ))
			{
			name[x] = 0;
			return;
			};
};

int main(int argc, char *argv[])
{
	FILE *fileRef;
	TIVarHeader aHeader;
	long count, size;
	long sum = 0;
	short s_sum;
	char *buff, *walk;
	char name[30];
	
	printf("\n\nExecuting Convert 2 Fargo...\nBy Bryan Turner\n\n");
	printf("File Name: %s\n", argv[1]);
	
	if ( argc > 1 )
		{
		printf("Opening file.\n");
		fileRef = fopen( argv[1], "rb+" );
		
		printf("Seeking.\n");
		fseek( fileRef, 0, SEEK_END );
		size = ftell( fileRef );
		fseek( fileRef, 0, SEEK_SET );
		
		buff = (char *)alloca(size);
		
		printf("Reading.\n");
		fread(buff, 1, size, fileRef);
		
		fclose( fileRef );
		
		printf("Creating file.\n");
		strcpy( name,argv[1] );
		walk = name;
		while ( *walk != 0 )
			walk++;
		strcpy( walk, ".92p" );
		
		fileRef = fopen( name, "wb+" );
		
		printf("Trimming.\n");
		
		size -= 260; 						// Delete leading data
		memcpy( buff, buff+260, size+1 );
		
		walk = (char *)buff + size - 1;		// Delete trailing zeros (leftovers from compilation)
		//do {
			while ( (*(unsigned char *)walk) != (unsigned char)0xDC )
				{
				size--;
				walk--;
				}
		//} while ( *(walk-1) != 0x40 );		// End when we find 0x40DC at the end
		
		//
		// Ok, file's in memory, now add everything up except last two bytes, then
		// change the last two bytes to be equal to the sum (reverse the two bytes though).
		//
		
		printf("Summing.\n");
		walk = buff;
		
		count = size;
		while ( count-- )
			sum += *(walk++);					// Sum everything up
		
		printf("Saving.\n");
		
		sum += (size >> 8) & 0xFF;
		sum += size & 0xFF;						// Size gets thrown in too
		
		SafeName( (char *)(argv[1]) );
		InitHeader( &aHeader, "Fargo program", argv[1], 0x12, size );
		fseek( fileRef, 0, SEEK_SET );
		
		count = sizeof(TIVarHeader);
		fwrite( &aHeader, 1, count, fileRef );	// Write out the header
		fwrite( buff, 1, size, fileRef );		// Write out program
		
		sum &= 0xFFFF;
		s_sum = (sum << 8) | (sum >> 8);		// Flip the bytes..
		fwrite( &s_sum, 1, 2, fileRef );		// Write out sum
		
		printf("Closing.\n");
		
		
		printf("Done!\n");
		}
};







//




