
#ifndef _GLOBALS_
#define _GLOBALS_

#include <conf.h>
#include <kernel.h>
#include <sem.h>
#include <q.h>
#include <proc.h>
#include <sleep.h>    
#include <mem.h>
#include <mark.h>
#include <Xinu.h>

// Number of vectors to install
#define NUMEVEC 17

typedef struct Globals
	{
	// ---------- ROMGlue.c ----------
	short Y;				// Used by the kprintf debugging function
	// ---------- clkint.c ----------
	short	curKey;			// Current keyboard entry
	char    areProcsAsleep;	/* FALSE if the sleep queue is empty	*/
	short   *sltop;			/* address of key part of top entry in	*/
							/* the sleep queue if areProcsAsleep==TRUE	*/
	Q_ID	sleepQ;
	short	preempt;		// Preemption counter
	
	// ---------- initialize.c ----------
	/* Declarations of major kernel variables */

	char	buf[32];				// kprintf buffer
	short	nextproc;				/* next process slot to use in create	*/
	short	nextqueue;				/* next slot in q structure to use	*/
	//WORD	*maxaddr;				/* max memory address (set by sizmem)	*/
	Process	theProcs[NPROC];		// Process structures
	QItem	theQs[NQENT];			// Queues and Semaphores
	
	//struct	mblock	memlist;		/* list of free memory blocks		*/

	/* active system status */
	//short	numproc;					/* number of live user processes	*/
	PROC_ID	CurPID;						// ID of currenty running process
	Q_ID	readyQ;						// The ready process queue
	PROC_ID	NULLPROC, TIPROC, LOADERPROC;	// PID of nullproc & TI-OS proc
	
	} Globals;


//
// The actual globals are stored in a data section, masquarading as a procedure.
//
extern void actualGlobals();

//
// BT: Define the variables below so we don't have to rewrite them all...
//
#define X (xinuGlobs.X)
#define Y (xinuGlobs.Y)
#define areProcsAsleep (xinuGlobs.areProcsAsleep)
#define sltop (xinuGlobs.sltop)
#define clockq (xinuGlobs.clockq)

#define devtab (xinuGlobs.devtab)
#define nextproc (xinuGlobs.nextproc)
#define nextsem (xinuGlobs.nextsem)
#define nextqueue (xinuGlobs.nextqueue)
#define maxaddr (xinuGlobs.maxaddr)
#define proctab (xinuGlobs.proctab)
#define semaph (xinuGlobs.semaph)
#define q (xinuGlobs.q)
#define memlist (xinuGlobs.memlist)

#define numproc (xinuGlobs.numproc)
#define currpid (xinuGlobs.currpid)
#define rdyhead (xinuGlobs.rdyhead)
#define rdytail (xinuGlobs.rdytail)

#define marks (xinuGlobs.marks)
#define nmarks (xinuGlobs.nmarks)
#define mkmutex (xinuGlobs.mkmutex)
#define ptmark (xinuGlobs.ptmark)
#define ptfree (xinuGlobs.ptfree)
#define ports (xinuGlobs.ports)
#define ptnextp (xinuGlobs.ptnextp)


extern struct Globals xinuGlobs;



#endif











