/* q.h - firstid, firstkey, isempty, lastkey, nonempty */
#ifndef	_Q_
#define	_Q_

/* q structure declarations, constants, and inline procedures		*/

// BT: The new Queue system significantly reduces the neccisary
//     number of Queue Items needed..
#define	NQENT	(NSEM + 2 + NPROC)
				// NSEM  : one queue struct for each semaphore
				// + 2   : ready & sleep queue structs
				// NPROC : message queues for each proc
				
				// ? BT: needed ? Yes if NPROC processes are allocated!
				// NPROC : one message for each message queue

typedef struct
	{
	short next;				// Offset to next free block
	short prev;				// Offset to previous free block
	char  flags;			// Implementation specific flags
	unsigned char size;		// Size of block (in 8-Byte chunks)
	short key;				// Implementation specific data
	} QItem;

typedef struct { void; } *Q_ID;
typedef struct { void; } *Q_NODE;
typedef struct { void; } *SEM_ID;
typedef struct { void; } *PROC_ID;

#define Q_FLAG    0
#define SEM_FLAG  1
#define PROC_FLAG 2
#define MARK_FLAG 4

/* inline list manipulation procedures */

/* BT: Old routines for reference...
#define	isempty(list)	(q[(list)].qnext >= NPROC)
#define	nonempty(list)	(q[(list)].qnext < NPROC)
#define	firstkey(list)	(q[q[(list)].qnext].qkey)
#define lastkey(tail)	(q[q[(tail)].qprev].qkey)
#define firstid(list)	(q[(list)].qnext)
*/

#define	isempty(list)	( ((QItem *)(list))->next == 0 )
#define	nonempty(list)	( ((QItem *)(list))->next != 0 )
#define	firstkey(list)	( ((QItem *)((char *)(list) + ((QItem *)(list))->next))->key )
#define lastkey(list)	( ((QItem *)((char *)(list) + ((QItem *)(list))->prev))->key )
#define firstid(list)	( (Q_NODE)((char *)(list) + ((QItem *)(list))->next) )

#define	EMPTY	-1		/* equivalent of null pointer		*/

#endif