//
// Xinu Functions Header (Kernel Version)
//
// Xinu for the TI-92
//

#include <Globals.h>

// Low Level functions
extern void ret_mon();
long set_evec( int offset, void (*func)() );
void INITRET();
void enable();
short disable( );
long SaveA4AndLoadGlobals();
void RestoreA4AndSR( long a4, short sr );
void RestoreA4( long a4 );

// Clock Functions
SYSCALL	sleep10( short n );
SYSCALL	unsleep( PROC_ID theProcess );

// Message Functions
SYSCALL	receive(short maxwait);
//SYSCALL	recvtim(short maxwait);
//SYSCALL	recvclr();
SYSCALL	send( PROC_ID theProcess, WORD msg );
SYSCALL	sendf( PROC_ID theProcess, WORD msg );

// Process Functions

PROC_ID create( void *procaddr, short ssize, short priority, short nargs, long args);
SYSCALL kill( PROC_ID theProcess );
int	ready (PROC_ID theProcess, short resch);
short resched();
SYSCALL resume(PROC_ID theProcess);
SYSCALL	suspend(PROC_ID theProcess);
SYSCALL GetSetState( PROC_ID theProcess, long data, short what );

#define chprio( a, b ) GetSetState( (a), (b), 0)
#define getpid() GetSetState( (PROC_ID)-1, 0, 0 )
#define getprio( a ) GetSetState( (a), 0, 0 )
#define setnok( nok, proc ) GetSetState( (proc), (nok), 1 )
// BT: Condensed procedures..
//SYSCALL chprio( PROC_ID theProcess, short newprio );
//PROC_ID getpid();
//SYSCALL getprio(PROC_ID theProcess);
//SYSCALL	setnok(PROC_ID nokProc, PROC_ID theProcess);



// Queue Functions
extern Q_ID NewQueue();
extern void Enqueue( Q_NODE theBlock, Q_ID theQueue );
extern Q_NODE Dequeue( Q_NODE theItem );
extern Q_NODE GetFirst( Q_ID theQueue );
extern Q_NODE GetLast( Q_ID theQueue );
extern void InsertByDelta( PROC_ID theProc, Q_ID theQueue, short theKey );
extern void InsertByKey( PROC_ID theProc, Q_ID theQueue, short theKey );

// Semaphore Functions
SEM_ID screate( short count );
SYSCALL sdelete( SEM_ID theSemaphore );
SYSCALL signaln( SEM_ID theSemaphore, short count );
SYSCALL	wait( SEM_ID theSemaphore );
SYSCALL GetSetSemCount( SEM_ID theSemaphore, short count );

#define scount( a ) GetSetSemCount( (a), -1 )
#define sreset( a, b ) GetSetSemCount( (a), (b) )
//SYSCALL scount( SEM_ID theSemaphore );
//SYSCALL sreset( SEM_ID theSemaphore, short count );

// Misc. Functions
void kprintf(char *fmt, ...);
SYSCALL	freemem(struct mblock *block, unsigned int size);
WORD *getmem(unsigned int nbytes);
WORD *getstk(unsigned int nbytes);
mark(int *loc);
panic (char *msg);
short GetKey();

