//* conint.s -  conint
#include <conf.h>
#include <kernel.h>


//*------------------------------------------------------------------------
//* conint  --  interrupt service routine for keyboard
//*------------------------------------------------------------------------

#define ZCONTROLA 0xfe00004

extern INTPROC	coniin();
extern long cpudelay;

asm int conint()
{
	movem.l	d0/d1/d7/a0/a1, -(sp)		// save d0, d1, d7, a0, a1

	jsr coniin

	jmp done

//
// read from RR3 of the chip
//
	move.l	%ZCONTROLA,a0	// address of A channel
	move.b	%0x3,(a0)		// select register 3	

	moveq	%20,d0			// must delay before reading
	move.l	cpudelay,d1
	asr.l	d1,d0
lup:
	subq.l	%1,d0
	bgt.s	lup

	move.b	(a0),d7			// d7 = RR3


//
// test for receive interrupt
//
//	btst	%0x5,d7			// xx1x xxxx = recv int. pending
//	beq	norecv
recv:
	jsr	coniin			// call input interrupt routine
norecv:

//
// now, reset the interrupt and return
//
done:
	move.l	%ZCONTROLA,a0		// address of A channel
	move.b	%0x38,(a0)		// reset interrupt

	movem.l	(sp)+,d0/d1/d7/a0/a1		// restore d0, d1, d7, a0, a1
	rte				// Return from interrupt
}