//* ctxsw.s - ctxsw

//*-----------------------------------------------------------------------------
//* ctxsw  --	actually perform context switch, saving and loading registers
//*		This routine is executed in kernel mode.
//*
//*-----------------------------------------------------------------------------

void ctxld(long *nregs);	// BT: context load (used by killed processes)
asm void ctxsw(long *oregs, long *nregs)
{
//
// BT: Edited and optimized..
//

/* BT: ctxsw stack
		  0,4,8,12,16,20,24,28,32,36,40,44,48,52,56
 0(sp): D:0,1,2,3 ,4 ,5 ,6 ,7,A:0,1 ,2 ,3 ,4 ,5 ,6
 
60(sp): return pc
64(sp): oregs
68(sp): nregs
*/
	movem.l	D0-D7/A0-A6,-(a7)		// Save all registers on stack
	move.l	64(sp),a0				// Load address of ProcTab->pcurstack
	move.l	a7,(a0)					// Save stack pointer (with regs saved on top)

	move.l	68(sp),a0				// Move address of new area into A7
ctx_load:
	move.l	(a0),a7					// Load Other process' stack pointer
	movem.l	(a7)+,D0-D7/A0-A6		// Restore all regs
	rts								// Return to subroutine (PC still on stack)

/* BT: ctxld stack
 0(sp): return pc
 4(sp): nregs
*/
	entry	ctxld
	move.l	4(a7),a7
	bra		ctx_load
}


