//* intr.s - disable(), restore(), enable()

#include <conf.h>
#include <kernel.h>


//---------------------------------------------------------
// enable all interrupts
//---------------------------------------------------------
asm void enable()
{
	clr.w	d0
	trap	%1			// Use TI-Trap to change interrupt levels
	rts
}

//---------------------------------------------------------
// disable(ps)    - disable interrupts, save old state in ps
// STATWORD ps  (short *ps)
//---------------------------------------------------------
asm short disable( )
{
	move.w	%0x0700,d0	// Use TI-Trap to change interrupt levels
	trap	%1
	rts
}

//---------------------------------------------------------
// restore(ps)    - restore interrupts to value in ps
// STATWORD ps    (short *ps)
//---------------------------------------------------------
asm void restore( short ps )
{
	move.w	4(sp),d0	// Use TI-Trap to change interrupt levels
	trap	%1
	rts
}

