//* ttyint.s -  Asm_ttyint
#include <conf.h>
#include <kernel.h>
#include <tty.h>
#include <Globals.h>

//
// BT: check for byte in input buffer of TI, if so, read it.
//     check for bytes in output buffer of Xinu, if so, write them
//

//*------------------------------------------------------------------------
//* ttyint  --  interrupt service routine
//*------------------------------------------------------------------------

#undef tty
#undef oldTTYInt

extern INTPROC	ttyiin( struct	tty	*iptr);
extern INTPROC	ttyoin( struct	tty *iptr);
extern ttybreak();
extern long cpudelay;


asm int ttyint()
{
	jsr		xinuGlobs.oldTTYInt	// Call the old interrupt first
	
	move.w	%0x2700, sr			// disable all interrupts

//	--- BT: should this be done in an interrupt?? Probably not...

	pea	xinuGlobs.tty
	jsr	ttyoin					// Call output interrupt routine

// --- BT: test if we are even looking for input first!

	//tst.w	readingKeys
	//bne		norecv
	
// Test for keys waiting to be read from keyboard buffer.
// TI-OS Interrupt handler processes raw keyboard data into ascii.
//
	tst.w	0x57B0				// Is there data to read? --- NOT ROM 2.1 compatable!!
	beq		norecv
recv:
	clr.w	0x57B0				// Mark data as read --- NOT ROM 2.1 compatable!!
	
	pea		xinuGlobs.tty
	jsr		ttyiin				// Call interrupt routine, and load the data
	
norecv:


ret:

	rte							// Return from interrupt, restore interupt mask
}