/* kprintf.c - kprintf */


#include "TIOS.h"
#include <Globals.h>

/*------------------------------------------------------------------------
 *  kprintf  --  kernel printf: formatted, unbuffered output to CONSOLE
 *------------------------------------------------------------------------
 */
 
#undef X
#undef Y
asm void kprintf( char *fmt, ...)
{
	
	move.w	%0x0700,d0			// Turn off interrupts
	trap	%1
	
	lea		store,a0
	movem.l	d2/d6-d7/a4,(a0)	// Save registers (ROM calls destroy D2)
	
	lea		actualGlobals,a4	// Load globals
	move.w	d0,d7				// Save interrupt level
	
	move.w	%0x0888,(0x600010)	// Reset Screen
	
	move.l	(a7)+,d6			// Save return address
	pea		xinuGlobs.buf		// push address of buffer
	jsr		TI_sprintf				// Print characters to buffer
	addq	#4,a7				// Pop off buffer addr
	
	move.l	d6,-(a7)			// Push return address back
	
	move.w	#1,-(a7)
	jsr		TI_FontSetSys			// Set 8-point font
	addq	#2,a7
	
	clr.w	-(a7)
	pea		xinuGlobs.buf
	move.w	xinuGlobs.Y, -(a7)
	clr.w	-(a7)
	jsr		TI_DrawStrXY			// Draw buffer
	lea		10(a7),a7
	
	move.w	xinuGlobs.Y,d0
	addq	#8,d0				// Next line
	andi.w	#0x7F,d0			// Mod 128
	move.w	d0,xinuGlobs.Y
	
	move.w	d7,d0				// Load old interrupt levels
	
	lea		store,a0			// A0 was trashed by ROM calls
	movem.l	(a0),d2/d6-d7/a4	// Restore registers
	
	trap	%1					// Restore interrupts
	rts
	
store:
	dc.l	0,0
}


