/* queue.c - dequeue, enqueue */

#include <conf.h>
#include <kernel.h>
#include <q.h>
#include <Globals.h>


// BT: Add theBlock into queue BEFORE theQueue
void Enqueue( Q_NODE theBlock, Q_ID theQueue )
{
	QItem *thePrev;
	#define theBlk	((QItem *)theBlock)
	#define theQ	((QItem *)theQueue)
	
	thePrev	= (QItem *)(((char *)theQueue) + theQ->prev);
	
	// him - me = offset from me to him
	
	 theBlk->prev = ((long)thePrev) - ((long)theBlk);	// Link block into free memory list
	 theBlk->next = ((long)theQ) - ((long)theBlk);		//    by calculating offsets...
	thePrev->next = -(theBlk->prev);					// Aren't offsets great!
	   theQ->prev = -(theBlk->next);

	#undef theBlk
	#undef theQ
}


// BT: Remove theItem from the queue it is in and return it
Q_NODE Dequeue( Q_NODE theItem )
{
	#define theQ ((QItem *)theItem)
	
	((QItem *)((char *)theQ + theQ->prev))->next += theQ->next;	// Unlink block from free memory list
	((QItem *)((char *)theQ + theQ->next))->prev += theQ->prev;	// Aren't offsets great!
	*((long *)&theQ->next) = 0;	// BT: set next and prev == 0 for safety;
	
	return theItem;
	
	#undef theQ
}



