/* resume.c - resume */

#include <Globals.h>

/*------------------------------------------------------------------------
 * resume  --  unsuspend a process, making it ready; return the priority
 *------------------------------------------------------------------------
 */

SYSCALL resume( PROC_ID theProcess )
{
	short sr;
	long a4;
#define theProc ((Process *)theProcess)
	int	prio;			// priority to return

	if (isbadpid(theProc) || theProc->pstate != PRSUSP)
		return(SYSERR);
	
	a4 = SaveA4AndLoadGlobals();
	sr = disable();
	
	prio = theProc->pprio;
	ready( theProcess, RESCHYES);
	
	RestoreA4AndSR(a4,sr);
	return(prio);
}
