/* sreset.c - sreset */

#include <Globals.h>

//
// Get or Set the Semaphore count
// BT: Replaces scount() and sreset()
//
// count < 0  : scount()
// count >= 0 : sreset()
//

SYSCALL GetSetSemCount( SEM_ID theSemaphore, short count )
{
	short sr; 
	long a4;    
	PROC_ID theProc;
#define theSem ((QItem *)theSemaphore)

	if (isbadsem(theSem) || theSem->key == SFREE )
		return(SYSERR);
	
	if ( count < 0 )
		return theSem->key;

	a4 = SaveA4AndLoadGlobals();
	sr = disable();
	
	while ((theProc=(PROC_ID)GetFirst((Q_ID)theSem)) != (PROC_ID)EMPTY)
		ready( theProc, RESCHNO );
		
	theSem->key = count;
	
	resched();
	
	RestoreA4AndSR(a4,sr);
	return(OK);
}



