/* suspend.c - suspend */

#include <Globals.h>

/*------------------------------------------------------------------------
 *  suspend  --  suspend a process, placing it in hibernation
 *------------------------------------------------------------------------
 */

SYSCALL	suspend( PROC_ID theProcess )
{
	short	temp, prio;			// priority returned
	short	sr; 
	long	a4;    
	
#define theProc ((Process *)theProcess)

	a4 = SaveA4AndLoadGlobals();
	sr = disable();
	
	temp = theProc->pstate;
	if ( isbadpid(theProc) ||
		(theProcess == xinuGlobs.NULLPROC) ||
		( temp != PRCURR &&
		temp != PRREADY))
		{
		RestoreA4AndSR(a4,sr);
		return(SYSERR);
		}
	
	theProc->pstate = PRSUSP;
	if ( temp == PRREADY )
		Dequeue( (Q_NODE)theProcess );
	else
		resched();
	
	
	prio = theProc->pprio;		// Copy priority AFTER suspention!
	RestoreA4AndSR(a4,sr);
	return prio;

#undef theProc
}


