/* ttyoin.c - ttyoin */

#include <conf.h>
#include <kernel.h>
#include <tty.h>
#include <io.h>
#include <slu.h>
#include <TI.h>


//
// BT: Just print the character.  Correctly word-wrap & scroll...
//

/*------------------------------------------------------------------------
 *  ttyoin  --  lower-half tty device driver for output interrupts
 *------------------------------------------------------------------------
 */
INTPROC	ttyoin(struct	tty   *iptr)
{
	register struct	TI_IO	*dptr;
	int	ct;

	dptr = iptr->ioaddr;
	
	if (iptr->ehead	!= iptr->etail)
		{
		dptr->putcharTI( iptr->ebuff[iptr->etail++] );	// BT: Draw a character onscreen (corrects for wrapping, etc..)
		
		if (iptr->etail	>= EBUFLEN)
			iptr->etail = 0;
		
		return 0;
		}
	
	if (iptr->oheld)									/* honor flow control	*/
		{
		ttyostop(iptr);
		return 0;
		}
	
	if ((ct=iptr->ocnt) > 0)
		{
		dptr->putcharTI( iptr->obuff[iptr->otail++] );	// BT: Draw a character onscreen 
	    
	    --iptr->ocnt;
		if (iptr->otail	>= OBUFLEN)
			iptr->otail = 0;
		if (ct > OBMINSP)
			signal(iptr->osem);
		else if	( ++(iptr->odsend) == OBMINSP)
			{
			iptr->odsend = 0;
			signaln(iptr->osem, OBMINSP);
			}
		}
	else
		ttyostop(iptr);
	
	return 0;
}
